#pragma once
#include "fs/devices/DeviceRegistry.h"

class ConsoleDevice : public Device
{
  public:
    // Initializer for DeviceRegistry.
    static Result<void> create();

    Result<usize> read(u8*, usize, usize) const override;

    Result<usize> write(const u8*, usize, usize) override;

    static void did_press_key(char key);

    bool blocking() const override;

    Result<u64> ioctl(int request, void* arg) override;

    StringView device_path() const override
    {
        return "console";
    }

    virtual ~ConsoleDevice() = default;
};
